#!/usr/bin/python
# -*- coding: utf-8 -*-

# Libervia: a Salut à Toi frontend
# Copyright (C) 2011, 2012, 2013, 2014 Jérôme Poisson <goffi@goffi.org>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.

# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from sat_frontends.tools import xmltools

import nativedom
import re

dom = nativedom.NativeDOM()


def html_sanitize(html):
    """Naive sanitization of HTML"""
    return html.replace('<', '&lt;').replace('>', '&gt;')

def html_strip(html):
    """Strip leading/trailing white spaces, HTML line breaks and &nbsp; sequences."""
    cleaned = re.sub(r"^(<br/?>|&nbsp;|\s)+", "", html)
    cleaned = re.sub(r"(<br/?>|&nbsp;|\s)+$", "", cleaned)
    return cleaned

def inlineRoot(xhtml):
    """ make root element inline """
    doc = dom.parseString(xhtml)
    return xmltools.inlineRoot(doc)

def convertNewLinesToXHTML(text):
    return text.replace('\n', '<br/>')

def XHTML2Text(xhtml):
    """Helper method to apply both html_sanitize and convertNewLinesToXHTML"""
    return convertNewLinesToXHTML(html_sanitize(xhtml))
